workflow:
  rules:
    - if: $CI_COMMIT_BRANCH != "main" &&  $CI_PIPELINE_SOURCE != "merge_request_event"
      when: never
    - when: always

stages:
  - test
  - build
  - deploy_dev
  - functional_test_dev
  - deploy_staging
  - deploy_prod

variables:
  DEV_PORT: "3000"
  STAGING_PORT: "4000"
  PROD_PORT: "5000"
  TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
  TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA
  #CI_DEBUG_TRACE: "true"

run_unit_tests:
  stage: test
  image: node:16.20.0-alpine
  cache:
    key: "$CI_COMMIT_REF_NAME"
    paths:
      - app/node_modules
    policy: pull-push
  tags:
    - linode
    - remote
    - docker
  before_script:
    - cd app
    - npm install
  script:
    - npm run test
  artifacts:
    when: always
    paths:
      - app/junit.xml
    reports:
      junit: app/junit.xml

sast:
  stage: test

build_image:
  stage: build
  services:
    - docker:dind
  tags:
    - linode
    - remote
    - shell
  before_script:
    - export PACKAGE_JSON_VERSION=$(cat app/package.json | jq -r .version)
    - export VERSION=$PACKAGE_JSON_VERSION.$CI_PIPELINE_IID
    - echo "VERSION=$VERSION" >> build.env
  script:
    - docker build -t $TAG_COMMIT -t $TAG_LATEST .
  artifacts:
    reports:
      dotenv: build.env

push_image:
  stage: build
  needs:
    - build_image
  tags:
    - linode
    - remote
    - shell
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t $TAG_COMMIT -t $TAG_LATEST .
    - docker push $TAG_COMMIT
    - docker push $TAG_LATEST

.deploy:
    tags:
      - linode
      - remote
      - shell
    variables:
      SERVER_IP: ""
      APP_PORT: ""
      DEPLOY_ENV: ""
      ENDPOINT: ""
    before_script:
 #     - echo $ID_RSA_SSH | sed -e "s/-----BEGIN OPENSSH PRIVATE KEY-----/&\n/" -e "s/-----END OPENSSH PRIVATE KEY-----/\n&/" -e "s/\S\{64\}/&\n/g"\ > server-key.pem
      - chmod og= $ID_RSA
    script:
      - scp -i $ID_RSA -o StrictHostKeyChecking=no ./docker-compose.yml $SERVER_USER@$SERVER_IP:/home/dabiko
      - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "
        docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY &&
        
        docker pull $TAG_COMMIT &&
        docker container rm -f $CI_REGISTRY_IMAGE || true &&
        
        export DC_IMAGE_NAME=$CI_REGISTRY_IMAGE &&
        export DC_IMAGE_TAG=$TAG_COMMIT &&
        export DC_APP_PORT=$APP_PORT &&
        export COMPOSE_PROJECT_NAME=$DEPLOY_ENV &&
        
        docker compose down &&
        docker compose up -d"
    environment:
      name: $DEPLOY_ENV
      url:  $ENDPOINT

deploy_to_dev:
  extends: .deploy
  stage: deploy_dev
  variables:
    SERVER_IP: $SERVER_IP
    APP_PORT: $DEV_PORT
    DEPLOY_ENV: development
    ENDPOINT: http://$SERVER_IP:${$DEV_PORT}

run_functional_test:
  stage: deploy_dev
  needs:
    - deploy_to_dev
  script:
    - echo "Running functional tests...."

deploy_to_staging:
  extends: .deploy
  stage: deploy_staging
  variables:
    SERVER_IP: $SERVER_IP
    APP_PORT: $STAGING_PORT
    DEPLOY_ENV: staging
    ENDPOINT: http://$SERVER_IP:${$STAGING_PORT}
  when: manual

run_performance_test:
  stage: deploy_staging
  needs:
    - deploy_to_staging
  script:
    - echo "Running performance tests...."

deploy_to_production:
  extends: .deploy
  stage: deploy_prod
  variables:
    SERVER_IP: $SERVER_IP
    APP_PORT: $PROD_PORT
    DEPLOY_ENV: production
    ENDPOINT: http://$SERVER_IP:${$PROD_PORT}

include:
  - template: Jobs/SAST.gitlab-ci.yml
